<!doctype html>
<html lang="en-us">
  <head>
    
    <meta charset="utf-8">
    <title>
      Concrete examples of HTMX and Django CBV
      
    </title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    
    
    
    
  <meta property="og:title" content="Active search: ListView filter">
  <meta property="og:url" content="/posts/active-search-listview-filter.html">
  
  
  <meta name="twitter:card" content="summary_large_image">

    <link rel="stylesheet" href="/static/prism.css" type="text/css" />
    <link rel="stylesheet" href="/static/style.css" type="text/css" />
    <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Lora&family=Space+Mono&display=swap" />

    <script src="/static/prism.js"></script>
    
  </head>
  <body>
    
    
      <header>
        <h1>
          <a href="/">
            Concrete examples of HTMX and Django CBV
          </a>
        </h1>
        <a href="#main" class="visually-hidden">jump to main content</a>
        <nav>
          <ul class="menu">
            <li><a href="/about">about</a></li>
            <li><a href="/">blog</a></li>
          </ul>
        </nav>
      </header>
    

    
    <main id="main">
      
  <article class="post">
    <h1 class="post__title">
      Active search: ListView filter
    </h1>
    <section class="post__meta">
      
        nov. 12, 2023
      
    </section>
    <section>
      <div id="outline-container-intro" class="outline-2">
<h2 id="intro">Intro</h2>
<div class="outline-text-2">
<p>
Here is a small tutorial on how to set up an active search by a ListView based on user typing.
</p>
</div>
</div>
<div id="outline-container-model-game" class="outline-2">
<h2 id="model-game">Model: Game</h2>
<div class="outline-text-2">
<div class="org-src-container">
<pre class="src src-python"><span style="color: #ff79c6;">from</span> django.db <span style="color: #ff79c6;">import</span> models

<span style="color: #ff79c6;">class</span> <span style="color: #bd93f9;">Game</span><span style="color: #61bfff;">(</span>models.Model<span style="color: #61bfff;">)</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">class</span> <span style="color: #bd93f9;">Meta</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">ordering</span> = <span style="color: #61bfff;">[</span><span style="color: #f1fa8c;">"french_name"</span><span style="color: #61bfff;">]</span>
     
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">bgg_pk</span> = models.CharField<span style="color: #61bfff;">(</span>max_length=<span style="color: #bd93f9; font-weight: bold;">200</span>, null=<span style="color: #8be9fd;">True</span>, blank=<span style="color: #8be9fd;">True</span><span style="color: #61bfff;">)</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">name</span> = models.CharField<span style="color: #61bfff;">(</span>max_length=<span style="color: #bd93f9; font-weight: bold;">200</span>, null=<span style="color: #8be9fd;">True</span>, blank=<span style="color: #8be9fd;">True</span><span style="color: #61bfff;">)</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">french_name</span> = models.CharField<span style="color: #61bfff;">(</span>default=<span style="color: #f1fa8c;">""</span>,
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>                              max_length=<span style="color: #bd93f9; font-weight: bold;">600</span>,
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>                              null=<span style="color: #8be9fd;">True</span>,
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>                              blank=<span style="color: #8be9fd;">True</span><span style="color: #61bfff;">)</span>
</pre>
</div>
</div>
</div>
<div id="outline-container-views-searchview" class="outline-2">
<h2 id="views-searchview">Views: SearchView</h2>
<div class="outline-text-2">
<p>
By looking at the get request, I&rsquo;m able to know if the request is from HTMX or not. This means, I can render one of my partial templates inside my already rendered HTML page from &ldquo;&rdquo; URL entry. Also, if user is using directly &ldquo;detail/&rdquo; or &ldquo;update/&rdquo; URLs (instead of HTMX using them). It will render an HTML page with the general template + the corresponding partial template. In consequence, these URLs are still valid even if they&rsquo;re not used by HTMX request.
By default, partial template is set on detail, this is changed using &ldquo;update/&rdquo; URL.
</p>

<div class="org-src-container">
<pre class="src src-python"><span style="color: #ff79c6;">from</span> django.views.generic <span style="color: #ff79c6;">import</span> DetailView, ListView
<span style="color: #ff79c6;">from</span> game.models <span style="color: #ff79c6;">import</span> Game

<span style="color: #ff79c6;">class</span> <span style="color: #bd93f9;">SearchView</span><span style="color: #61bfff;">(</span>ListView<span style="color: #61bfff;">)</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">model</span> = Game
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">template_name</span> = <span style="color: #f1fa8c;">"home.html"</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">context_object_name</span> = <span style="color: #f1fa8c;">"games"</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">result_template</span> = <span style="color: #f1fa8c;">"search_results.html"</span>
 
<span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">def</span> <span style="color: #50fa7b;">get</span><span style="color: #61bfff;">(</span><span style="color: #ff79c6;">self</span>, request, *args, **kwargs<span style="color: #61bfff;">)</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">if</span> request.META.get<span style="color: #61bfff;">(</span><span style="color: #f1fa8c;">"HTTP_HX_REQUEST"</span><span style="color: #61bfff;">)</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">self</span>.<span style="color: #ffc9e8;">template_name</span> = <span style="color: #ff79c6;">self</span>.result_template
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">return</span> <span style="color: #ffb86c;">super</span><span style="color: #61bfff;">()</span>.get<span style="color: #61bfff;">(</span>request, *args, **kwargs<span style="color: #61bfff;">)</span>
     
<span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">def</span> <span style="color: #50fa7b;">get_queryset</span><span style="color: #61bfff;">(</span><span style="color: #ff79c6;">self</span><span style="color: #61bfff;">)</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">query</span> = <span style="color: #ff79c6;">self</span>.request.GET.get<span style="color: #61bfff;">(</span><span style="color: #f1fa8c;">"search"</span>, <span style="color: #f1fa8c;">""</span><span style="color: #61bfff;">)</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">return</span> Game.objects.<span style="color: #ffb86c;">filter</span><span style="color: #61bfff;">(</span>name__icontains=query<span style="color: #61bfff;">)</span>
</pre>
</div>
</div>
</div>
<div id="outline-container-urls" class="outline-2">
<h2 id="urls">URLs</h2>
<div class="outline-text-2">
<p>
&ldquo;update/&rdquo; URL pass a new value to the partial_template attribute.
</p>
<div class="org-src-container">
<pre class="src src-python"><span style="color: #ff79c6;">from</span> django.conf <span style="color: #ff79c6;">import</span> settings
<span style="color: #ff79c6;">from</span> django.conf.urls.static <span style="color: #ff79c6;">import</span> static
<span style="color: #ff79c6;">from</span> django.urls <span style="color: #ff79c6;">import</span> path

<span style="color: #ff79c6;">from</span> game.views <span style="color: #ff79c6;">import</span> SearchView

<span style="color: #ffc9e8;">urlpatterns</span> = <span style="color: #61bfff;">[</span>
<span style="color: #40e748e26524;"> </span>   path<span style="color: #ff79c6;">(</span><span style="color: #f1fa8c;">""</span>, SearchView.as_view<span style="color: #50fa7b;">()</span>, name=<span style="color: #f1fa8c;">"home"</span><span style="color: #ff79c6;">)</span>,
<span style="color: #61bfff;">]</span> + static<span style="color: #61bfff;">(</span>settings.MEDIA_URL, document_root=settings.MEDIA_ROOT<span style="color: #61bfff;">)</span>
</pre>
</div>
</div>
</div>
<div id="outline-container-templates" class="outline-2">
<h2 id="templates">Templates</h2>
<div class="outline-text-2" id="text-templates">
</div>
<div id="outline-container-home-html" class="outline-3">
<h3 id="home-html">home.html</h3>
<div class="outline-text-3">
<div class="org-src-container">
<pre class="src src-html">{% extends "base.html" %}
{% block title %}Accueil{% endblock title %}

{% block content %}
<span style="color: #40e748e26524;"> </span> {% include "header/header.html" %}
 
<span style="color: #40e748e26524;"> </span> &lt;<span style="color: #50fa7b;">section</span> <span style="color: #ffc9e8;">class</span>=<span style="color: #f1fa8c;">"game-list"</span> <span style="color: #ffc9e8;">id</span>=<span style="color: #f1fa8c;">"search-results"</span>&gt;
<span style="color: #40e748e26524;"> </span>   {% include "search_results.html" %}
<span style="color: #40e748e26524;"> </span> &lt;/<span style="color: #50fa7b;">section</span>&gt;
{% endblock content %}
</pre>
</div>
</div>
</div>
<div id="outline-container-search-results-html" class="outline-3">
<h3 id="search-results-html">search_results.html</h3>
<div class="outline-text-3">
<div class="org-src-container">
<pre class="src src-html">{% for game in games %}
<span style="color: #40e748e26524;"> </span> &lt;<span style="color: #50fa7b;">div</span> <span style="color: #ffc9e8;">class</span>=<span style="color: #f1fa8c;">"game"</span>&gt;
<span style="color: #40e748e26524;"> </span>   &lt;<span style="color: #50fa7b;">a</span> href = <span style="color: #f1fa8c;">"{% url 'game_description' game.id %}"</span>&gt;
<span style="color: #40e748e26524;"> </span>   &lt;<span style="color: #50fa7b;">h2</span>&gt;<span style="font-weight: bold; font-style: italic; text-decoration: underline;">{{ game.french_name }}</span>&lt;/<span style="color: #50fa7b;">h2</span>&gt;
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span> &lt;<span style="color: #50fa7b;">p</span> class = <span style="color: #f1fa8c;">"booking.game_week_price"</span>&gt;{{ game.week_price }}&#8364;&lt;/<span style="color: #50fa7b;">p</span>&gt;
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span> {% if game.image %}
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   &lt;<span style="color: #50fa7b;">img</span> <span style="color: #ffc9e8;">class</span>=<span style="color: #f1fa8c;">"game_img"</span> <span style="color: #ffc9e8;">src</span>=<span style="color: #f1fa8c;">"{{ game.image.url }}"</span>&gt;
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span> {% endif %}
<span style="color: #40e748e26524;"> </span>   &lt;/<span style="color: #50fa7b;">a</span>&gt;
<span style="color: #40e748e26524;"> </span> &lt;/<span style="color: #50fa7b;">div</span>&gt;
{% endfor %}
</pre>
</div>
</div>
</div>
<div id="outline-container-header-html" class="outline-3">
<h3 id="header-html">header.html</h3>
<div class="outline-text-3">
<div class="org-src-container">
<pre class="src src-html">{% extends "base.html" %}

{% block title %}Header{% endblock title %}

{% block content %}

&lt;<span style="color: #50fa7b;">header</span>&gt;
<span style="color: #40e748e26524;"> </span> {% include "header/search_bar.html" %}
&lt;/<span style="color: #50fa7b;">header</span>&gt;

{% endblock content %}
</pre>
</div>
</div>
</div>
<div id="outline-container-search-bar-html" class="outline-3">
<h3 id="search-bar-html">search_bar.html</h3>
<div class="outline-text-3">
<div class="org-src-container">
<pre class="src src-html">&lt;<span style="color: #50fa7b;">form</span> <span style="color: #ffc9e8;">method</span>=<span style="color: #f1fa8c;">"GET"</span> <span style="color: #ffc9e8;">action</span>=<span style="color: #f1fa8c;">"{% url 'home' %}"</span>&gt;
<span style="color: #40e748e26524;"> </span> {% csrf_token %}
<span style="color: #40e748e26524;"> </span> &lt;<span style="color: #50fa7b;">input</span> <span style="color: #ffc9e8;">class</span>=<span style="color: #f1fa8c;">"form-control"</span> <span style="color: #ffc9e8;">type</span>=<span style="color: #f1fa8c;">"search"</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>    <span style="color: #ffc9e8;">name</span>=<span style="color: #f1fa8c;">"search"</span> <span style="color: #ffc9e8;">placeholder</span>=<span style="color: #f1fa8c;">"Trouver votre jeux ..."</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>    <span style="color: #ffc9e8;">hx-get</span>=<span style="color: #f1fa8c;">""</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>    <span style="color: #ffc9e8;">hx-trigger</span>=<span style="color: #f1fa8c;">"keyup changed, search"</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>    <span style="color: #ffc9e8;">hx-target</span>=<span style="color: #f1fa8c;">"#search-results"</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>    <span style="color: #ffc9e8;">hx-swap</span>=<span style="color: #f1fa8c;">"innerHTML"</span>&gt;
&lt;/<span style="color: #50fa7b;">form</span>&gt;
</pre>
</div>
</div>
</div>
</div>

    </section>
  </article>

    </main>

    
    
      <footer>&copy; Copyright 2023 Simon Chevolleau</footer>
    

  </body>
</html>
